#!/bin/sh


echo "Running bddEmbed experiment..."

BDD_DIR=bdds
OUTPUT=embed.log
EXP_DIR=experiments/embed

### for all bdds we have, starting with the smallest
#`ls -S -r $BDD_DIR` 
#ftp3.bdd mmgt20.bdd abp4.bdd dpd75.bdd over12.bdd furnace17.bdd key10.bdd dartes.bdd
for bdd_file in `ls -S -r $BDD_DIR`
do
  # remove .bdd suffix
  EXPERIMENT_NAME=`basename $bdd_file .bdd`

  # for every logic
  for logic in 2Bool 3QBool 4Bool 4FTO 6Coffee 6QBool 6FTO 8Bool 9QBool 16Bool 16FTO
    do
    echo "Running: ${EXPERIMENT_NAME}_${logic}"
      ### run the experiment
    java -Xmx128m -Dlogger.file.name=$ROOT/log-cfg/xbel.log.cfg edu.toronto.cs.experiments.BddEmbedExperiment $BDD_DIR/$bdd_file $EXP_DIR ${EXPERIMENT_NAME}_${logic} $logic >> $OUTPUT 2>&1
  done
done

