#!/bin/sh

####
#### builds a giant jar of all libraries we happen to use, 
#### just drop a library into $ROOT/lib/buildLib and run this to 
#### create $ROOT/lib/buildLib.jar
####

JARSCRATCH=/tmp/xbelDistJarScratch.$USER
LIBDIR=$ROOT/lib

echo "Making xbel.jar"

## remove a working directory if there is one
if [ -d $JARSCRATCH ] ; then
 rm -rf $JARSCRATCH
fi

## create a new clean work dir
mkdir $JARSCRATCH

## unjar all build libraries
cd $JARSCRATCH 
find $LIBDIR/buildLib -name "*.jar" -exec jar xfv "{}" ";"

## final clean up
rm -rf $JARSCRATCH/META-INF
rm -f $LIBDIR/xbel.jar

## UGLY but should work for now
## first copy all of our sources into the temp dir
## then remove all .java files
echo "Copying xbel sources"
cp -fav $ROOT/edu .
echo "Removing source files"
rm -rf `find -name '*.java'`

# generate giant jar file
jar -c0f $LIBDIR/xbel.jar *

### that's it, remove work dir
cd ..
rm -rf $JARSCRATCH



