#!/bin/sh

###
### Experiment runner script
###

LOGICS="2Bool 3QBool 4Bool 4FTO 6Coffee 6QBool 6FTO 9QBool 16Bool 16FTO"

MVSETS="mdd jmbtdd cubdd cubdd_reorder"

### Do only CUDD ommiting 2Bool
#MVSETS="cubdd cubdd_reorder"
LOGICS="3QBool 4Bool 4FTO 6Coffee 6QBool 6FTO 9QBool 16Bool 16FTO"


MVSETS="mdd jmbtdd"
LOGICS="16Bool"

EXP_RUNNER="java -Xmx600m  -Dlogger.file.name=$ROOT/log-cfg/xbel.log.cfg edu.toronto.cs.experiments.ExperimentRunner"

# Number of variables
#VARS=10
VARS=6
#SAMPLE_SIZE=10
SAMPLE_SIZE=1

OUTDIR=experiments/mc${VARS}vars/
EXP_NAME=${OUTDIR}mc${VARS}vars_
REORDER=false

FUNCTION=mc
FUNCARGS="3 5"

for logic in $LOGICS
do
  echo "Processing: $logic"
  for mvset in $MVSETS
    do
     if [ $mvset = 'cubdd_reorder' ] ; then
	 mvset='cubdd'
	 REORDER=true
     else
	 REORDER=false
     fi
     echo "Using MvSet: $mvset"
     for i in 3 #20 30 40 50 60
     do
       echo "number of minterms is $i"
       $EXP_RUNNER $logic $mvset $VARS $SAMPLE_SIZE ${EXP_NAME}${i}_${REORDER}_$logic $REORDER $FUNCTION $FUNCARGS $i
     done
    done
done