#!/bin/sh


echo "Running mc experiment..."

MODEL_BDD=experiments/mc/elevator
OUTPUT=mc.log
EXP_DIR=experiments/mc2
PROPS_DIR=experiments/mc/props

EXP_NAME=`basename $MODEL_BDD`

for prop in $PROPS_DIR/* 
do
  echo "Doing $prop"
  PROP_NAME=`basename $prop`
  #2Bool 3QBool 4Bool 4FTO 6Coffee 6QBool 6FTO 8Bool 9QBool 16Bool 16FTO
  for logic in 16Bool 6Coffee 6FTO 9QBool 
  do
    echo "Current logic is: $logic"
    for dd_type in jadd 
    do
      echo "Using mdd implementation: $dd_type"
      cat $prop | xcheck --smv true --mvset $dd_type edu.toronto.cs.experiments.SMVBddModule $logic ${MODEL_BDD}.ord ${MODEL_BDD}.bdd > ${EXP_DIR}/${EXP_NAME}_${PROP_NAME}_${logic}_${dd_type}.out 2>&1
    done
  done
done


