#!/bin/sh


echo "Running mc experiment..."

MODEL_BDD=experiments/mc/elevator
OUTPUT=mc.log
EXP_DIR=experiments/mc
PROPS_DIR=experiments/mc/props

EXP_NAME=`basename $MODEL_BDD`

for prop in $PROPS_DIR/* 
do
  echo "Doing $prop"
  PROP_NAME=`basename $prop`
  #2Bool 
  for logic in 3QBool 4Bool 4FTO 6Coffee 6QBool 6FTO 8Bool 9QBool 16Bool 16FTO
  do
    echo "Current logic is: $logic"
    for noise_level in 5 20 40 50 60 70 80 90 100
    do
      echo "Noise level: $noise_level"
      cat $prop | xcheck --smv true --mvset mdd edu.toronto.cs.experiments.SMVBddNoiseModule $logic ${MODEL_BDD}.ord ${MODEL_BDD}.bdd $noise_level > ${EXP_DIR}/${EXP_NAME}_${PROP_NAME}_${logic}_${noise_level}.out 2>&1
    done
  done
done


