#!/bin/sh


echo "Running mvproduct experiment..."

BDD_DIR=bdds
OUTPUT=mvnoise2.log
EXP_DIR=experiments/mvnoise2

### for all bdds we have, starting with the smallest
#`ls -S -r $BDD_DIR` 
#ftp3.bdd mmgt20.bdd abp4.bdd dpd75.bdd over12.bdd furnace17.bdd key10.bdd dartes.bdd
for bdd_file in abp4.bdd key10.bdd
do
  # remove .bdd suffix
  EXPERIMENT_NAME=`basename $bdd_file .bdd`TF

  ### for noise_levels 20, 5, and 40
  #5 20 40 50 60 70 80 90 100 
  for noise_level in 5 10 15 20 30 40 50 60 70 80 90 100
  do
    ## add noise_level to the name
    ### for 2, 3 and 4 viewpoints
    #6Coffee 6QBool 9QBool
    for viewpoints in 4Bool
    do
      echo "Running: ${EXPERIMENT_NAME}_${viewpoints}_${noise_level}"
      ### run the experiment
      java -Xmx600m -Dlogger.file.name=$ROOT/log-cfg/xbel.log.cfg edu.toronto.cs.experiments.MvNoiseExperiment2 $BDD_DIR/$bdd_file $EXP_DIR ${EXPERIMENT_NAME}_${viewpoints}_${noise_level} $viewpoints $noise_level >> $OUTPUT 2>&1
    done
  done
done

