#!/bin/sh


echo "Running mvpriority experiment..."

BDD_DIR=bdds
OUTPUT=mvpriority2.log
EXP_DIR=experiments/priority

#mmgt20.bdd abp4.bdd dpd75.bdd over12.bdd furnace17.bdd key10.bdd dartes.bdd dme2-16.bdd
### for all bdds we have, starting with the smallest
for bdd_file in ftp3.bdd 
do
  # remove .bdd suffix
  EXPERIMENT_NAME=`basename $bdd_file .bdd`

  ### for noise_levels 20, 5, and 40
  for noise_level in 20 50 60 70 80 90 100
  do
    ## add noise_level to the name
    ### for 2, 3 and 4 viewpoints --- here they are fto sizes
    for viewpoints in 3 4 6 16
    do
      echo "Running: ${EXPERIMENT_NAME}_${viewpoints}_${noise_level}"
      ### run the experiment
      java -Xmx600m -Dlogger.file.name=$ROOT/log-cfg/xbel.log.cfg edu.toronto.cs.experiments.MvPriorityExperiment $BDD_DIR/$bdd_file $EXP_DIR ${EXPERIMENT_NAME}_${viewpoints}_${noise_level} $viewpoints $noise_level >> $OUTPUT 2>&1
    done
  done
done

