#!/bin/sh


echo "Running mvproduct experiment..."

BDD_DIR=bdds
OUTPUT=mvproduct.log
EXP_DIR=experiments/mvproduct

### for all bdds we have, starting with the smallest
for bdd_file in `ls -S -r $BDD_DIR` 
do
  # remove .bdd suffix
  EXPERIMENT_NAME=`basename $bdd_file .bdd`

  ### for noise_levels 20, 5, and 40
  for noise_level in 20 5 40 
  do
    ## add noise_level to the name
    ### for 2, 3 and 4 viewpoints
    for viewpoints in 2 3 4
    do
      echo "Running: ${EXPERIMENT_NAME}_${viewpoints}_${noise_level}"
      ### run the experiment
      java -Xmx600m -Dlogger.file.name=$ROOT/log-cfg/xbel.log.cfg edu.toronto.cs.experiments.MvProductExperiment $BDD_DIR/$bdd_file $EXP_DIR ${EXPERIMENT_NAME}_${viewpoints}_${noise_level} $viewpoints $noise_level > $OUTPUT 2>&1
    done
  done
done

