#!/usr/bin/perl

open (IN, "$ARGV[0]");
while (<IN>) {
  # expand +=, -=
  s#(\w+)\s+([+-])=(.+)#\1 = \1 \2 \3#;

  # rewrite assert
  s#assert\s*\((.+)\)\s*;#if (!(\1)) { ERROR: goto ERROR; }#;

  # rewrite nondet
  s#nondet_\w+\s*\(\s*\)#YASM_NONDET#g;
  s#"NONDET"#YASM_NONDET#g;

  # convert char literals
  if (m#'(\\?.)'#) {
    my $ascii_to_dec = ord($1);
    s#'\\?.'#$ascii_to_dec#;
  }

  # convert octal literals
  if (m#'\\([0-7]{3})'#) {
    my $oct_to_dec = oct($1);
    s#'\\([0-7]{3})'#$oct_to_dec#;
  }
  print;
}
close (IN);
