function f = mvproduct(sampleName, numViewpointsRange, noiseRange, numSamples, markers)

res = zeros(numSamples,length(numViewpointsRange)*length(noiseRange) )
sampleFmt = [ sampleName, '_%d_%d'];
legendlabels = cell(1, length(numViewpointsRange)*length(noiseRange))
for i=1:length(numViewpointsRange)
  for j=1:length(noiseRange)
    legendlabels((i-1)*length(noiseRange)+j)=cellstr(sprintf('%d viewpoints, %d disagreements', numViewpointsRange(i), noiseRange(j)))
    res(:, (i-1)*length(noiseRange)+j) = transpose(slurp2parms('/w/10/share/experiments/mvproduct2', sampleFmt, numViewpointsRange(i), noiseRange(j), 100))
  end
end

  h = plot(res)
  title (['MV Product Experiment: ', sampleName])
  xlabel('Samples')
  ylabel('Ratio')
  legend(h, legendlabels)
  for i=1:length(numViewpointsRange)*length(noiseRange)
    set(h(i), 'Marker', markers(i))
  end
