% do sparse-random-function experiment plotting.
% rows are lattices, columns matrices
function f=sparser(datapoints, sigdig, logics, markers)

res = zeros(length(datapoints), length(logics));
fmt = sprintf ('%%.%df', sigdig);

for i=1:length(logics),
    for j=1:length(datapoints),
        res(j, i) = fnam1parm(char(logics(i)), 'sparseA', fmt, datapoints(j))
    end
end

     h = plot(datapoints,res)
     title('Sparse Random Functions (# of Variables Constant)')
     xlabel('Density')
     ylabel('(Number of MDD nodes)/(Number of JIMDD nodes)')
     legend(h, logics)
     for i=1:length(logics),
     set(h(i), 'Marker', markers(i))
     end
     saveas(gcf, 'sparseA.eps')

for i=1:length(logics),
    for j=1:length(datapoints),
       res(j, i) = fnam1parm(char(logics(i)), 'sparseB', fmt, datapoints(j))
    end
end

       h = plot(datapoints,res)
      title('Sparse Random Functions (State-Space Constant)')
      xlabel('Density')
      ylabel('(Number of MDD nodes)/(Number of JIMDD nodes)')
     legend(h, logics)
     for i=1:7,
     set(h(i), 'Marker', markers(i))
     end
     saveas(gcf, 'sparseB.eps')


