function f=varyvar(datapoints, vars, sigdig, logic, markers)

res = zeros(length(datapoints), length(vars));
fmt = sprintf ('%%.%df', sigdig);
legendlabels = cell(size(vars))
for i=1:length(vars),
    legendlabels(i)=cellstr(sprintf('%d variables', vars(i)))
    for j=1:length(datapoints),
        ident = sprintf('sparseA%d_', vars(i))
        res(j, i) = fnam1parm(logic, ident, fmt, datapoints(j))
    end
end

     h = plot(datapoints,res)
     title(['Sparse Random Functions: ', logic])
     xlabel('Density')
     ylabel('(Number of MDD nodes)/(Number of JIMDD nodes)')

     legend(h, legendlabels)
     for i=1:length(vars),
     set(h(i), 'Marker', markers(i))
     end
     saveas(gcf, ['vv',logic,'.eps'])

