package edu.toronto.cs.expr;

/** 
 * A binding operator; associates a name with a type or a value.
 * <p>
 * For example, x:INT, x:y&gt;5, x:y+z.
 * 
 * @author Kelvin Ku (kelvin@cs.toronto.edu)
 * @version 
 */
public class BindOp extends NamedOp
{
  public static final BindOp BIND = new BindOp (":", 2);

  public BindOp (String name, int arity)
  {
    super (name, arity);
  }

  public static final Expr name (Expr e)
  {
    return e.arg (0);
  }

  public static final Expr type (Expr e)
  {
    return e.arg (1);
  }

  public static final Expr value (Expr e)
  {
    return e.arg (1);
  }

  public static final Expr bind (Expr name, Expr type)
  {
    return name.getFactory ().op (BIND).binApply (name, type);
  }

  public static final boolean isBind (Expr e)
  {
    return e.op () == BIND;
  }
}
