package edu.toronto.cs.expr;

/**
 * C Array Type.
 *
 * Children:
 * range type
 * static size
 */
public class CArrayTypeOp extends CTypeOp implements PrefixOp
{
  public CArrayTypeOp (int tuid)
  {
    super ("arrayT", -1, tuid);
  }

  public static boolean isCArrayType (Expr e)
  {
    return (e.op () instanceof CArrayTypeOp);
  }

  public static Expr arrayRange (Expr e)
  {
    return e.arg (0);
  }

  public static Expr arraySize (Expr e)
  {
    return ((e.arity () >= 2) ? e.arg (1) : null);
  }
}
