package edu.toronto.cs.expr;

/**
 * Represents a bb (basic block); used as a stub for parsing, then discarded.
 *
 * Children:
 * stmtList	(Tuple)
 * succList	(Tuple)
 */
public class CBasicBlockOp extends AbstractOperator
{
  Integer id;

  public CBasicBlockOp (Integer id)
  {
    super ("bb", 2);
    this.id = id;
  }

  public static boolean isCBasicBlock (Expr e)
  {
    return (e.op () instanceof CBasicBlockOp);
  }

  public static Integer getId (Expr e)
  {
    return ((CBasicBlockOp) e.op ()).id;
  }

  public static Expr getStmtList (Expr e)
  {
    return e.arg (0);
  }

  public static Expr getSuccList (Expr e)
  {
    return e.arg (1);
  }
}
