package edu.toronto.cs.expr;

/**
 * Represents a callExpr.
 *
 * Children:
 * callee	(Addr)
 * args		(Tuple)
 */
public class CCallExprOp extends CStmtOp
{
  public static final CCallExprOp CALL_EXPR = new CCallExprOp ("call", 2);

  private CCallExprOp (String opName, int arity)
  {
    super (opName, arity);
  }

  public static boolean isCCallExpr (Expr e)
  {
    return e.op () == CALL_EXPR;
  }

  public static Expr getCallee (Expr e)
  {
    return e.arg (0).arg (0);
  }

  public static Expr getArgs (Expr e)
  {
    return e.arg (1);
  }
}
