package edu.toronto.cs.expr;

import java.util.*;
import edu.toronto.cs.yasm.cfg.*;

/**
 * Represents a functionDecl.
 *
 * Children:
 * resultDecl	(CResultDecl)
 * argList	(Tuple)
 * locals	(Tuple)
 * body		(Tuple)	(optional/to be discarded)
 */
public class CFunctionDeclOp extends CNamedDeclOp implements CContextOp
{
  public CFunctionDeclOp (String fName, int uid, Expr context)
  {
    super ("functionDecl", 4, uid, context, fName);
  }

  public static Expr resultDecl (Expr e)
  {
    return e.arg (0);
  }

  public static Expr args (Expr e)
  {
    return e.arg (1);
  }

  public static Expr locals (Expr e)
  {
    return e.arg (2);
  }

  public static Expr body (Expr e)
  {
    if (e.arity () > 3)
      return e.arg (3);

    return null;
  }

  public static boolean isCFunctionDecl (Expr e)
  {
    return (e.op () instanceof CFunctionDeclOp);
  }
}
