package edu.toronto.cs.expr;

public class CILAssignOp extends NamedOp
{
  // assign
  // 0 expr (lhs)
  // 1 expr (rhs)

  public static final CILAssignOp ASSIGN = new CILAssignOp (":=", 2);

  private CILAssignOp (String name, int arity)
  {
    super (name, arity);
  }

  // Creation method

  /** Creates an assignment expression {@code lhs := rhs}.
   *
   * @param lhs an <code>Expr</code> value
   * @param rhs an <code>Expr</code> value
   */
  public static final Expr assign (Expr lhs, Expr rhs)
  {
    return lhs.getFactory (). op (CILAssignOp.ASSIGN).binApply (lhs, rhs);
  }

  /** Creates an assignment expression {@code lhs := rhs}.
   *
   * @param lhs an <code>Expr</code> value
   * @param rhs an integer value
   */
  public static final Expr assign (Expr lhs, int rhs)
  {
    return assign (lhs, lhs.getFactory (). intExpr (rhs));
  }

  public static final boolean isAssign (Expr e)
  {
    return e.op () instanceof CILAssignOp;
  }
}
