package edu.toronto.cs.expr;

/**
 * Declaration with an optional initializer.
 *
 * Children:
 * type
 * init
 */
public abstract class CInitTypedDeclOp extends CTypedDeclOp
{
  public CInitTypedDeclOp (String opName, int uid, 
			   Expr context, String declName)
  {
    // -- expressions with initializer may have one or two children,
    // -- depending on whether the initialization is actually present
    // -- to account for that we allow arbitrary arity
    super (opName, -1, uid, context, declName);
  }

  static public boolean isCInitTypedDecl (Expr e)
  {
    return e.op () instanceof CInitTypedDeclOp;
  }

  public static final Expr initExpr (Expr e)
  {
    return ((e.arity () >= 2) ? e.arg (1) : null);
  }  
}
