package edu.toronto.cs.expr;

/**
 * Abstracts common features of structs and unions.
 *
 * Children:
 * One or more FieldDecls.
 */
abstract public class CRecordOp extends CTypeOp implements CContextOp
{
  String tag;

  public CRecordOp (String opName, int tuid, String _tag)
  {
    super (opName, -1, tuid);
    tag = _tag;
  }

  public static String tag (Expr e)
  {
    return ((CRecordOp) e.op ()).tag;
  }

  public static boolean isCRecord (Expr e)
  {
    return (e.op () instanceof CRecordOp);
  }
}
