package edu.toronto.cs.expr;

import static edu.toronto.cs.expr.CTypeDeclOp.*;

/**
 * Abstracts the common features of types.
 */
public abstract class CTypeOp extends AbstractOperator implements PrefixOp
{
  int tuid;

  public CTypeOp (String opName, int arity, int _tuid)
  {
    super (opName, arity);
    tuid = _tuid;
  }

  public boolean equals (Object o)
  {
    return super.equals (o) && (o instanceof CTypeOp) &&
      tuid == ((CTypeOp)o).tuid;
  }

  public int hashCode ()
  {
    return tuid;
  }

  public static final boolean isCType (Expr e)
  {
    return (e.op () instanceof CTypeOp);
  }

  public static final int typeUID (Expr e)
  {
    return ((CTypeOp) e.op ()).tuid;
  }
}
