package edu.toronto.cs.expr;

/**
 * A uniquelly named operator. An implementation must ensure that
 * there is exactly one {@code NamedOp} object with any given name.
 *
 * @author <a href="mailto:arie@pcawf.sei.cmu.edu">Arie Gurfinkel</a>
 * @version 1.0
 */
public abstract class NamedOp extends AbstractOperator
{
  
  public NamedOp (String _name, int _arity)
  {
    super (_name, _arity);
  }
  

  public boolean equals (Object o)
  {
    return this == o;
  }

  public int hashCode ()
  {
    return System.identityHashCode (this);
  }
  
}
