package edu.toronto.cs.expr;


/**
 * Operator representing a constant string.
 *
 * @author <a href="mailto:arie@pcawf.sei.cmu.edu">Arie Gurfinkel</a>
 * @version 1.0
 */
public class StringOp extends NullaryOperator
{
  String str;
  
  public StringOp (String _str)
  {
    str = _str;
  }
  
  public int hashCode ()
  {
    return str.hashCode ();
  }
  
  public boolean equals (Object o)
  {
    return o != null && (o instanceof StringOp) && 
      str.equals (((StringOp)o).str);
  }

  public String name ()
  {
    return str;
  }
  
  public String toString ()
  {
    return name ();
  }
  

  public static final boolean isString (Expr e)
  {
    return (e.op () instanceof StringOp);
  }
  
  public static final String str (Expr e)
  {
    return ((StringOp) e.op ()).name ();
  }
  
  
}
