package edu.toronto.cs.openjgraph;

import salvo.jesus.graph.*;
import salvo.jesus.graph.visual.*;
import salvo.jesus.graph.visual.layout.*;
import salvo.jesus.graph.visual.drawing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import edu.toronto.cs.gui.OpenJGraphFrame;

import java.util.*;
import java.awt.Color;
import java.io.*;



import edu.toronto.cs.util.*;


public class OpenJGraph
{
  
  public DirectedGraph  graph;
  Vertex rootNode;

  public OpenJGraph ()
  {
    graph = new DirectedGraphImpl();
  }
  /*
  public OpenJGraph (String graphName)
  {
    graph = new Graph (graphName);
  }
  */

  public String toString ()
  {
    //  StringWriter stringWriter = new StringWriter ();
    //graph.printGraph (stringWriter);
    //return stringWriter.toString ();
    
    return "not done yet"; //XXX
  }

  public DirectedGraph getGraph ()
  {
    return graph;
  }


  public Vertex getRoot ()
  {
    return rootNode;
  }
  public OpenJGraph setRoot (OpenJNode v)
  {
    rootNode = v.node;
    return this;
  }
  

  /*
    creates a new node in g and returns the node for attribute setting
  */
  public OpenJNode node()
  {
    OpenJNode node = new OpenJNode ();
    return node;
  }
  


  /*** graph attributes ***/
  /*  public OpenJGraph orientation (String s)
  {
    graph.setAttribute ("orientation", s);
    return this;
  }

  public OpenJGraph center (boolean v)
  {
    graph.setAttribute ("center", String.valueOf (v));
    return this;
  }
  
  public OpenJGraph size (String v)
  {
    graph.setAttribute ("size", v);
    return this;
  }
  
  public OpenJGraph editable (boolean v)
  {
    graph.setEditable (v);
    return this;
  }
  
  public OpenJGraph errorWriter (PrintWriter w)
  {
    graph.setErrorWriter (w);
    return this;
  }
  
  public OpenJGraph errorWriter (OutputStream v)
  {
    return errorWriter (new PrintWriter (v, true));
  }
  */
  
  /*  public void drawOJ()
    {
      
    }
  */
  
  public class OpenJNode
  {
    // -- OpenJ's representation of a node
    Vertex node;
    
    public OpenJNode ()
    {
      node = graph.getGraphFactory ().createVertex ();
      
      try
	{
	  graph.add(node);
	}
      catch (Exception e)
	{
	    assert false : e;
	}
      
    }
    public OpenJNode label (String value)
    {
      node.setLabel (value);
      return this;
    }
    public OpenJNode color (String value)
    {
      // node.setAttribute ("color", value);
      return this;
    }
    public OpenJNode color (Color c)
    {
      return color (ColorUtil.toHexString (c));
    }

    public OpenJNode shape (String value)
    {
      //node.setAttribute ("shape", value);
      return this;
    }
    public OpenJNode fontFamily (String family)
    {
      //node.setAttribute ("fontname", family);
      return this;
    }
    public OpenJNode fontStyle (String style)
    {
      // XXX no way to set fontStyle
      return this;
    }
    public OpenJNode style (String style)
    {
      //node.setAttribute ("style", style);
      return this;
    }
    public OpenJNode border (String type)
    {
      // XXX no way to set border use different shapes instead
      return this;
    }

    // -- creates a new edge XXX todo
    public OpenJEdge edge (OpenJNode tail)
      {
	OpenJEdge _edge = new OpenJEdge (this, tail);
	return _edge;
      }

    public Vertex getNode ()
    {
      return node;
    }
  }

    
  public class OpenJEdge
  {
    Edge edge;

    public OpenJEdge (OpenJNode head, OpenJNode tail)
    {
      //  edge = new Edge (graph , tail.getNode (), head.getNode ());
      try
	{
	  edge = graph.addEdge(head.getNode(),tail.getNode());
	  this.fixLabel ().label ("");
	}
      catch (Exception e)
	{
	  assert false : e;
	}
      
      

    }
    
    public OpenJEdge color (String v)
    {
      //  edge.setAttribute ("color", v);
      return this;
    }
    
    public OpenJEdge fixLabel ()
    {      //  edge.setAttribute ("color", v);
      edge.setFollowVertexLabel(false);
      return this;
    }

    public OpenJEdge color (Color c)
    {
      return color (ColorUtil.toHexString (c));
    }

    public OpenJEdge label (String v)
    {
      edge.setLabel(v);
      return this;
    }
    
    
    public OpenJEdge lineType (String v)
    {
      // XXX don't know how to do this yet
      return this;
    }
  }
  

  //Test function
  public static void main( String args[] ) throws Exception {
    
    OpenJGraph mygraph = new OpenJGraph();
    
    OpenJNode a = mygraph.node ().label ("nodeA");
    OpenJNode b = mygraph.node ().label ("nodeB");

    a.edge (b);
    
    OpenJGraphFrame    app = new OpenJGraphFrame(mygraph.getGraph (), mygraph.getRoot ());
    
    app.showDirectedGraph();
    app.setTitle("TestTreeLayout");
    app.setVisible( true );
    app.vgraph.layout();
  }

}
