package edu.toronto.cs.proof;

import java.util.*;

import edu.toronto.cs.algebra.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.modelchecker.*;

public class DisjProofStep extends ProofStep
{
  
  DisjProofStrategy strategy;
  
  public DisjProofStep (AlgebraValue _v, MvSet _state, String stateName,
		       CTLNode _consequent, DisjProofStrategy _strategy)
  {
    super (_v, _state, stateName, _consequent);
    strategy = _strategy;
  }
  
  
  public boolean unfold()
  {
    CTLNode[] props = new CTLNode [2];
    AlgebraValue[] vals = new AlgebraValue [2];
    MvSetModelChecker mc = ProofStepFactory.getMC ();

    BitSet tbs; // temporary bit-set
    IAlgebra alg = v.getParentAlgebra ();
    
    //AlgebraValue[] stateEnv; // vector of assignments corresponding to state

    //stateEnv = getStateAsArray ();

   
    makeSingleState ();
    // XXX Again evaluate left hand side of \/, but now the code
    // XXX is different than the one for /\, great! This should
    // XXX be rolled in into model checker
    int i=0;    
    props [0] = consequent.getLeft();
    vals [0] = mc.checkCTL (props [0], state).getValue ();
    
    //tbs = mc.checkCTL (props[0]).cofactor(stateEnv).getImage();

//     for (i = 0; i < tbs.length (); i++)
//       if (tbs.get (i))
// 	break;

//     vals[0] = alg.getValue(i);
    

    props [1] = consequent.getRight();
    vals [1] = mc.checkCTL (props [1], state).getValue ();
    
    //tbs = mc.checkCTL(props[1]).cofactor(stateEnv).getImage();
//     for (i=0; i<tbs.length(); i++)
//       if (tbs.get(i))
// 	break;
//     vals[1] = alg.getValue(i);

    tbs = strategy.choosePaths (vals, props);

    for (i = 0; i < tbs.length (); i++)
      if (tbs.get (i))
	antecedents.add (ProofStepFactory.makeProofStep (vals [i],
							 state,
							 props [i]));
    unfolded = true;
    return true;
  }

  public Object accept(ProofVisitor pv, Object info)
  {
    return pv.visitOrStep(this,  info);
  }
  
  
}

