package edu.toronto.cs.proof;

import edu.toronto.cs.mvset.*;
import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;
import java.util.*;

public class EUProofStep extends ProofStep
{
  

  public EUProofStep(AlgebraValue _v,
			MvSet _state,
			String _stateName,
		      CTLNode _consequent)
  {
    super(_v, _state, _stateName, _consequent);
  }
  
  // this is unfolded into an EUi proof step..
  // but first we have to find i!
  public boolean unfold()
  {
    MvSetFactory fac = state.getFactory ();
    IAlgebra alg = state.getAlgebra ();
    MvSetModelChecker mc = ProofStepFactory.getMC ();

    //AlgebraValue[] stateEnv;
    AlgebraValue res;
    
    //stateEnv = getStateAsArray ();
    makeSingleState ();
    
    int i = -1; // start i=0 and increment until reached
    do 
      {
	i++;
	// model-check EUi
	res = 
	  mc.checkCTL (consequent.getLeft ().eu(i, consequent.getRight ()),
		       state).getValue ();
      }
    while (!v.equals (res));

    antecedents.add 
      (ProofStepFactory.makeProofStep(v,
				      state,
				      consequent.getLeft().
				      eu(i, consequent.getRight())));
    unfolded = true;
    return true;
  }


  public Object accept(ProofVisitor pv, Object info)
  {
    return pv.visitEUStep(this,  info);
  }
  
}

