package edu.toronto.cs.yasm.cfg;

/**
 * A CFGSimplifier is an interface for simplifying (or manipulation) a
 * control flow graph. 
 */

public interface CFGSimplifier
{
  /**
   * Simplifies (or transforms) a control flow graph. The method is
   * allowed to modify the input CFG as a side effect.
   *
   * @param cfg control flow graph to simplify
   * @return a CFGraph representing the simplified graph
   */
  CFGraph simplify (CFGraph cfg);
}
