package edu.toronto.cs.yasm.eqsolver;


public class IntDomain
{
  public static final IntDomain theDomain = new IntDomain ();
  
  protected Value TOP;
  protected Value BOT;
  

  protected IntDomain ()
  {
    TOP = new Value (0);
    BOT = new Value (0);
  }
  

  public Value intValue (int i)
  {
    return new Value (i);
  }

  public Value top ()
  {
    return TOP;
  }

  public Value bot ()
  {
    return BOT;
  }
  

  public boolean isConst (Value v)
  {
    return v != TOP && v != BOT;
  }
  
  public boolean isTop (Value v)
  {
    return v == TOP;
  }
  public boolean isBot (Value v)
  {
    return v == BOT;
  }
  

  public class Value
  {
    int v;
    
    public Value (int v)
    {
      this.v = v;
    }
    
    public int intValue ()
    {
      return v;
    }
    
    public boolean equals (Object o)
    {
      if (this == o) return true;

      // -- INVARIANT: this != o
      // -- CONCLUSION: if either this or o are not numeric constants,
      // -- they are not equal; if this and o are constants, must
      // -- check their values
      return o != null && (o.getClass () == Value.class) &&
	isConst (this) && isConst ((Value)o) && ((Value)o).v == v;
    }
    
    public int hashCode ()
    {
      return v;
    }
    

    public String toString ()
    {
      if (isTop (this)) return "top";
      if (isBot (this)) return "bot";
      return String.valueOf (v);
    }
    
  }
  
}
