package edu.toronto.cs.yasm.pcfa;

import edu.toronto.cs.mvset.MvRelation;
import edu.toronto.cs.mvset.MvSet;

/**
 * Describe class FunctionSummaryEdge here.
 *
 *
 * Created: Tue Jun 14 10:18:44 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class FunctionSummaryEdge extends SummaryEdge 
{

  CallEdge callEdge;

  boolean selfCall;
  
  MvSet sumCallPreVarCube;
  

  /**
   * Creates a new <code>FunctionSummaryEdge</code> instance.
   *
   */
  public FunctionSummaryEdge (Node.NodeId _src, 
			      Node.NodeId _dst,
			      MvRelation _reln) 
  {
    super (_src, _dst, _reln);
    selfCall = false;
    sumCallPreVarCube = null;
  }



  /**
   * Creates a new <code>FunctionSummaryEdge</code> instance.
   *
   */
  public FunctionSummaryEdge (Node.NodeId _src, 
			      Node.NodeId _dst,
			      MvRelation _reln,
			      boolean _selfCall,
			      MvSet _sumCallPreVarCube) 
  {
    super (_src, _dst, _reln);
    selfCall = _selfCall;
    sumCallPreVarCube = _sumCallPreVarCube;
  }

  public void setCallEdge (CallEdge v)
  {
    callEdge = v;
  }
  
  public CallEdge getCallEdge ()
  {
    return callEdge;
  }
  
  public boolean isSelfCall ()
  {
    return selfCall;
  }
  

//   /**
//    * this <code>bwdImage</code> function is almost as same as that in
//    * <code>MvRelnEdge</code>, except for that we compute the values of
//    * the caller's local predicates and restore them after the
//    * computation.
//    *
//    * @param oldNode a <code>NodeSet</code> value
//    * @param newNodes a <code>NodeSet</code> value
//    * @param isDisjoin a <code>boolean</code> value
//    * @return a <code>boolean</code> value
//    */
//   public boolean bwdImage (NodeSet oldNodes, 
// 			   NodeSet newNodes, 
// 			   boolean isDisjoin)
//   {
 
//     // -- used to save save the caller's local predicates values
//     MvSet localPredsOfCaller = null;

//     boolean changed = false;


//     // XXX problem, what if getDst is null?!
//     MvSet res = null;
    
//     Node dstNode = oldNodes.get (getDst ());
    
//     if (dstNode != null)
//       {
// 	// -- if self-call statement, save the values of
// 	// -- caller's local predicates
// 	if (isSelfCall ())
// 	  {	    
// 	    if (sumCallPreVarCube!=null)
// 	      {
// 		localPredsOfCaller = 
// 		  dstNode.getValue ().existAbstract (sumCallPreVarCube);
// 	      }
// 	    else
// 	      localPredsOfCaller = dstNode.getValue ();
// 	  }
	
// 	res = reln.bwdImage (dstNode.getValue ());	
	
// 	if (localPredsOfCaller!=null)
// 	  {

// 	    System.err.println (" *** !!!!test *** ");
	    
// 	    System.err.println ("look at localPredsOfCaller : " + 
// 				localPredsOfCaller);


// 	    System.err.println ("look at res : " + 
// 				res);

// 	    // -- restore caller's local predicates values
// 	    res = res.and (localPredsOfCaller); 


	    
// 	    System.err.println ("look at res again: " + 
// 				res);
	    
// 	    System.err.println (" *** !!!!test *** ");

// 	  }
//       }

//     Node srcNode = newNodes.get (getSrc ());

//     // -- two cases, srcNode is null (i.e., false)
//     // -- or srcNode is not null
    

//     if (res != null && srcNode != null)
//       {
// 	if(isDisjoin)
// 	  {
// 	    res = res.or (srcNode.getValue ());	    
// 	  }
	
// 	changed = !res.equals (srcNode.getValue ());
//       }
//     else if (res == null && srcNode != null)
//       {
// 	// -- srcNode is not null
// 	// -- res is  null
// 	// -- two choices: 
// 	// -- srcNode.getValue is false, then no change
// 	// -- srcNode.getValue is not false, then change to false
// 	MvSet bot = srcNode.getValue ().getFactory ().bot ();
// 	if (!srcNode.getValue ().equals (bot))
// 	  {
// 	    res = bot;
// 	    changed = true;
// 	  }
//       }
//     else if (res != null)
//       changed = true;
    
    
//     if (changed)
//       newNodes.add (getSrc (), res);
//     return changed;
//   }


//   /**
//    * this <code>fwdImage</code> function is almost as same as that in
//    * <code>MvRelnEdge</code>, except for that we compute the values of
//    * the caller's local predicates and restore them after the
//    * computation.
//    *
//    * @param oldNode a <code>NodeSet</code> value
//    * @param newNodes a <code>NodeSet</code> value
//    * @param isDisjoin a <code>boolean</code> value
//    * @return a <code>boolean</code> value
//    */  
//   public boolean fwdImage (NodeSet oldNodes, NodeSet newNodes)
//   {
//     // -- used to save save the caller's local predicates values
//     MvSet localPredsOfCaller = null;

//     boolean changed = false;

//     // -- if self-call statement, save the values of
//     // -- caller's local predicates
//     if (isSelfCall ())
//       {	    
// 	if (sumCallPreVarCube!=null)
// 	  {
// 	    localPredsOfCaller = 
// 	      oldNodes.get (getSrc ()).getValue ().
// 	      existAbstract (sumCallPreVarCube);
// 	  }
// 	else
// 	  localPredsOfCaller = oldNodes.get (getSrc ()).getValue ();
//       }
    
//     MvSet res = reln.fwdImage (oldNodes.get (getSrc ()).getValue ());

//     if (localPredsOfCaller!=null)
//       {
// 	// -- restore caller's local predicates values
// 	res = res.and (localPredsOfCaller); 
//       }
    
//     Node dstNode = newNodes.get (getDst ());
    
//     if (dstNode != null)
//       {
// 	res = res.or (dstNode.getValue ());
// 	changed = !res.equals (dstNode.getValue ());
//       }
//     else
//       changed = true;
    
//     if (changed)
//       newNodes.add (getDst (), res);

//     return changed;
//   }



}
