package edu.toronto.cs.yasm.pcfa;

import edu.toronto.cs.mvset.MvRelation;
import edu.toronto.cs.mvset.MvSet;

/**
 * Describe class MvRelnEdge here.
 *
 *
 * Created: Wed Jun  8 13:10:58 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class MvRelnEdge extends Edge 
{
  
  MvRelation reln;

  public MvRelnEdge (Node.NodeId _src, Node.NodeId _dst, MvRelation _reln)
  {
    super (_src, _dst);
    reln = _reln;
  }


  public MvRelation getRelation ()
  {
    return reln;
  }
  public void setRelation (MvRelation v)
  {
    reln = v;
  }
  
  public boolean bwdImage (NodeSet oldNodes, 
			   NodeSet newNodes, 
			   boolean isDisjoin)
  {
    boolean changed = false;


    // XXX problem, what if getDst is null?!
    MvSet res = null;
    
    Node dstNode = oldNodes.get (getDst ());
    
    if (dstNode != null)
      res = reln.bwdImage (dstNode.getValue ());


    Node srcNode = newNodes.get (getSrc ());

    // -- two cases, srcNode is null (i.e., false)
    // -- or srcNode is not null
    

    if (res != null && srcNode != null)
      {
	if(isDisjoin)
	  {
	    res = res.or (srcNode.getValue ());
	  }
	
	changed = !res.equals (srcNode.getValue ());
      }
    // XXX this case only comes up in non-termination computation
    // XXX it is incorrect for reachability!!!
    // XXX we should clean this very soon!
    else if (!isDisjoin && res == null && srcNode != null)
      {
	// -- srcNode is not null
	// -- res is  null
	// -- two choices: 
	// -- srcNode.getValue is false, then no change
	// -- srcNode.getValue is not false, then change to false
	MvSet bot = srcNode.getValue ().getFactory ().bot ();
	if (!srcNode.getValue ().equals (bot))
	  {
	    res = bot;
	    changed = true;
	  }
      }
    else if (res != null)
      changed = true;
    
    
    if (changed)
      newNodes.add (getSrc (), res);
    return changed;
  }
  
  public boolean fwdImage (NodeSet oldNodes, NodeSet newNodes)
  {
    boolean changed = false;
    
    MvSet res = reln.fwdImage (oldNodes.get (getSrc ()).getValue ());
    Node dstNode = newNodes.get (getDst ());
    
    if (dstNode != null)
      {
	res = res.or (dstNode.getValue ());
	changed = !res.equals (dstNode.getValue ());
      }
    else
      changed = true;
    
    if (changed)
      newNodes.add (getDst (), res);

    return changed;
  }
  
  
  public boolean equals (Object o)
  {
    if (o == null) return false;
    if (o == this) return true;
    if (!(o instanceof MvRelnEdge)) return false;
    return super.equals ((Edge) o);
  }

  public int hashCode ()
  {
    // -- we ignore the relation in equality computation
    return super.hashCode ();
  }
  
  
  
}
