package edu.toronto.cs.yasm.pcfa;

import edu.toronto.cs.util.Primes;
import edu.toronto.cs.mvset.MvSet;

import java.util.Iterator;
import java.util.Arrays;


/**
 * Describe class Node here.
 *
 *
 * Created: Wed Jun  8 12:58:44 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class Node 
{

  protected NodeId id;

  protected MvSet value;
  
  
  public Node (NodeId _id)
  {
    this (_id, null);
  }
  
  /**
   * Creates a new <code>Node</code> instance.
   *
   */
  public Node (NodeId _id, MvSet _value) 
  {
    id = _id;
    value = _value;
  }

  public NodeId getId ()
  {
    return id;
  }

  public MvSet getValue ()
  {
    return value;
  }

  public NodeId nodeId (int v)
  {
    return new NodeId (v);
  }

  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();
    sb.append ("Node: " + getId () + " \n");
    sb.append (dumpMvSet (getValue ()));
    sb.append ("\n\n\n");
    return sb.toString ();
  }
  
  
  private String dumpMvSet (MvSet mvSet)
  {
    StringBuffer sb = new StringBuffer ();
    for (Iterator it = mvSet.cubeIterator (); it.hasNext ();)
      {
	//System.err.println (Arrays.asList ((Object[])it.next ()).toString ());
	sb.append (Arrays.asList ((Object[])it.next ()).toString ());
	sb.append ("\n");
      }
    return sb.toString ();
  }


  public boolean equals (Object o)
  {
    if (o == null) return false;
    if (o == this) return true;
    if (! (o instanceof Node)) return false;
    return getId ().equals (((Node)o).getId ());
  }

  public int hashCode ()
  {
    return getId ().hashCode ();
  }


  public static class NodeId 
  {
    int id;

    public NodeId (int _id)
    {
      id = _id;
    }
    
    
    public String toString ()
    {
      return String.valueOf (intValue ());
    }
    
    public int intValue ()
    {
      return id;
    }

    
    public boolean equals (Object o)
    {
      if (o == null) return false;
      if (o == this) return true;
      if (!(o instanceof NodeId)) return false;
      return ((NodeId)o).intValue () == intValue ();
    }
    
    public int hashCode ()
    {
      // -- XXX this may require extra thought
      return (int) (((long) id) * Primes.getPrime (0));
    }
    
    
  }

  public static void main (String[] args)
  {
    Node.NodeId nodeid = new Node.NodeId (4);
  }
  
}
