package edu.toronto.cs.yasm.pprogram;

import java.io.PrintWriter;

import edu.toronto.cs.cparser.block.Block;
import edu.toronto.cs.expr.*;
import edu.toronto.cs.yasm.wp.*;

import static edu.toronto.cs.expr.CILFunctionCallOp.*;
import static edu.toronto.cs.expr.CCallExprOp.*;

public class FunctionCallEpilogue extends PrllAsmtPStmt
{
  // -- call this was generated from
  FunctionCallPStmt call;

  public FunctionCallEpilogue (FunctionCallPStmt _call)
  {
    super (_call.getParent (), (Expr) null);
    call = _call;
  }

  /*
  public void setLabel (String label)
  {
    System.err.println (">>> FunctionCallEpilogue " + label);
    super.setLabel (label);
  }
  */

  public Object accept (PProgramVisitor v, Object o)
  {
    return v.visitFunctionCallEpilogue (this, o);
  }
  
  public WPComputer getWPComputer ()
  {
    Expr lhs = call.getReturnVar ();
    if (wpComputer == null)
    {
      if (lhs != null)
      {
	if (isCILFunctionCall (call.getSourceExpr ()))
	{
	  ExprFactory fac = getParent ().getParent ().getExprFactory ();
	  Expr rhs = call.getCallee ().getReturnValueVar ();
	  wpComputer = new ExprWPComputer
	    (fac.op (CILAssignOp.ASSIGN).binApply (lhs, rhs));
	}
	else if (isCCallExpr (call.getSourceExpr ()))
	{
	  Expr rhs = call.getCallee ().getReturnValueVar ();
	  ExprFactory fac = rhs.getFactory ();
	  wpComputer = new ExprWPComputer
	    (fac.op (CStmtOp.MODIFY_EXPR).binApply (lhs, rhs));
	}
	else
	  throw new RuntimeException
	    ("Unknown sourceExpr " + call.getSourceExpr ());
      }
      else
      {
        wpComputer = ExprWPComputer.ID;
      }
    }

    return wpComputer;
  }

  public FunctionCallPStmt getCall ()
  {
    return call;
  }

  public int getLineNum ()
  {
    return getCall ().getLineNum ();
  }
  

  public void printMe (PrintWriter out)
  {
    if (getSourceBlock () != null)
      out.println ("epilogue (" + call.getSourceBlock ().getLineNum () + ")");
    else  
    {
      out.println (getId () + "/" + getLabel () + ": epilogue");
      String rv = null;
      if (call.getReturnVar () != null)
	rv = call.getReturnVar ().toString ();
      if (rv == null) rv = "<nothing>";
      out.println (rv + " := " + call.getCallee ().getReturnValueVar ());
    }
  }
}
