package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.expr.*;
import java.io.PrintWriter;
import java.util.*;


/**
 * Represents a non-deterministic update
 * v := {H(a_1,b_1), H(a_2,b_2), ...}
 *
 * @author <a href="mailto:arie@kanga.fm.sandbox">Arie Gurfinkel</a>
 * @version 1.0
 */
public class NDAsmtPStmt extends AsmtPStmt
{
  // -- the updates over which we have a non-deterministic choice
  // -- for now these will be represented by AsmtPStmt so there is
  // -- a duplication of the variable name
  // -- v := { v := H(a_1, b_1),
  //           v := H(a_2, b_2), ... }
  List updates;



  public NDAsmtPStmt (Expr var)
  {
    super (var, null, null);
    updates = new ArrayList ();
  }
  
  public List getUpdates ()
  {
    return updates;
  }

  public void addUpdate (Expr tCond, Expr fCond)
  {
    updates.add (new AsmtPStmt (getVar (), tCond, fCond));
  }
  
  public void addUpdate (AsmtPStmt u)
  {
    assert (u.getVar ().equals (var)) : "Attempt to add wrong update";
      updates.add (u);
  }
  public void printMe (PrintWriter out)
  {
    out.print (updates);
  }


  public Expr getTrueCond ()
  {
    assert false;
    return null;
  }
  
  public Expr getFalseCond ()
  {
    assert false;
    return null;
  }
  
  public void setTrueCond ()
  {
    assert false;
  }
  public void setFalseCond ()
  {
    assert false;
  }
  
  
  
  
  
}
