package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.expr.*;
import edu.toronto.cs.tp.*;
import edu.toronto.cs.cparser.block.Block;

import edu.toronto.cs.yasm.abstractor.DeclsParserUtil;
import static edu.toronto.cs.expr.CILDeclarationOp.*;

public class PDecl
{
  Expr sourceExpr;

  public PDecl (Block b)
  {
    throw new UnsupportedOperationException ();
  }

  public PDecl (Expr _sourceExpr)
  {
    sourceExpr = _sourceExpr;
  }

  public Expr getSourceExpr ()
  {
    return sourceExpr;
  }

  public Object accept (PProgramVisitor v, Object o)
  {
    return v.visitDecl (this, o);
  }
  

  /**
   * Declares this declaration to the theorem prover.
   *
   * @deprecated
   * @param tp an <code>ITheoremProver</code> value
   */
  public void declare (ITheoremProver tp)
  {
    Expr e = DeclsParserUtil.parseExprDecl (sourceExpr, tp);

    if (e == null)
      System.err.println ("declare: got a null CVCL Expr");  
  }
  
  /** 
   * Adds this to the given symbol table. 
   * 
   * @param st 
   */
  public void declare (SymbolTable st)
  {
    assert st != null;
    assert isDecl (sourceExpr);

    // System.out.println ("declare:\n" + sourceExpr);

    ExprFactory fac = sourceExpr.getFactory ();

    Expr baseType = getBaseType (sourceExpr);

    Expr stType;

    if (CILTypeSpecifierOp.isIntT (baseType))
      stType = fac.op (SimpleTypeOp.INT);
    else
      throw new RuntimeException ("unknown base type in " + sourceExpr);

    // apply pointers, if any
    stType = ptrChain (getNumPtrs (sourceExpr), stType);

    Expr name = getDeclNameExpr (sourceExpr);
    System.err.println ("*** " + name + " " + stType);
    st.put (name, stType);
  }

  private Expr ptrChain (int depth, Expr baseType)
  {
    if (depth == 0)
      return baseType;

    return CompoundTypeOp.ptrT (ptrChain (depth - 1, baseType));
  }
}
