package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.expr.*;
import java.io.PrintWriter;
import java.util.List;

/** 
 * PSwitchCase.java 
 *
 * A guarded goto representing a case of a switch statement.
 *
 * @author Kelvin Ku (kelvin@cs.toronto.edu)
 * @version 
 */
public class PSwitchCase
{
  PCond cond;
  GotoPStmt gotoStmt;

  public PSwitchCase (PCond _cond, GotoPStmt _gotoStmt)
  {
    cond = _cond;
    gotoStmt = _gotoStmt;
  }

  public PCond getCond ()
  {
    return cond;
  }

  public GotoPStmt getGoto ()
  {
    return gotoStmt;
  }

  public boolean isDefaultCase ()
  {
    return cond.getOrigCond () == null;
  }

  public void printMe (PrintWriter out)
  {
    out.print (cond + "\t");
    gotoStmt.printMe (out);
  }
}
