package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.mvset.*;


public class SkipMvRelation implements MvRelation
{
  MvSet invariant;
  MvSet existAbstractFwdCube;
  MvSet existAbstractBwdCube;


  public SkipMvRelation (MvSet _invariant)
  {
    invariant = _invariant;
    existAbstractFwdCube = null;
    existAbstractBwdCube = null;
  }

  public SkipMvRelation (MvSet _invariant,
			 MvSet _existAbstractFwdCube,
			 MvSet _existAbstractBwdCube)
  {
    invariant = _invariant;
    existAbstractFwdCube =  _existAbstractFwdCube;
    existAbstractBwdCube = _existAbstractBwdCube;
  }


  public void setTrans (MvSet v)
  {
    throw new RuntimeException ("not implemented");
  }
  
  public MvSet fwdImage (MvSet v)
  {
    if (existAbstractFwdCube!=null)
      return v.existAbstract (existAbstractFwdCube);
    else
      return v;
  }
  public MvSet dualBwdImage (MvSet v)
  {
    return bwdImage(v.not ()).not ();
  }

  public MvSet bwdImage (MvSet v)
  {
    if (existAbstractBwdCube!=null)
      return v.existAbstract (existAbstractBwdCube);
    else
      return v;
  }
  public MvSet toMvSet ()
  {
    throw new RuntimeException ("not implemented");
  }
  


  /**
   * return cube of pre-state variables
   *
   */
  public MvSet getPreVariablesCube ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");

  }


  /**
   * get cube of post-state variables
   *
   */
  public MvSet getPostVariablesCube ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");

  }



  /**
   * get map from pre- to post-state variables
   *
   */
  public int[] getPreToPostMap ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");
      
  }



  /**
   * get map from post- to pre-state variables
   *
   */
  public int[] getPostToPreMap ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");
      
  }
    


  
}
