package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.expr.*;

import edu.toronto.cs.cparser.block.*;

import java.io.PrintWriter;


public class WhilePStmt extends IfPStmt
{
  GotoPStmt headGoto;

  public WhilePStmt (PFunctionDef def, Block sourceBlock, PCond cond,
		     PStmt whileBody)
  {
    super (def, sourceBlock, cond, whileBody, null);
    headGoto = new GotoPStmt (this);
    whileBody.setTail (headGoto); 
  }

  public WhilePStmt (PFunctionDef def, Expr sourceExpr, PCond cond,
		     PStmt whileBody)
  {
    super (def, sourceExpr, cond, whileBody, null);
    headGoto = new GotoPStmt (this);
    whileBody.setTail (headGoto); 
  }


  public Object accept (PProgramVisitor v, Object o)
  {
    return v.visitWhile (this, o);
  }
  
  public GotoPStmt getHeadGoto ()
  {
    return headGoto;
  }

  public void printMe (PrintWriter out)
  {
    out.print (getId () + "/" + getLabel () + ": ");

    if (sourceBlock != null)
      out.println ("while (" + cond + ") " + thenGoto + " else " + elseGoto +
		   " (" + sourceBlock.getLineNum () + ")");

    if (sourceExpr != null)
      out.println ("while (" + cond + ") goto " + thenGoto.getTargetLabel () +
        " else goto " + elseGoto.getTargetLabel ());
  }

  public int getLineNum ()
  {
    Expr src = getSourceExpr ();
    if (src == null) return super.getLineNum ();
    
    return RationalOp.getN (src.arg (2));
  }

}
