package edu.toronto.cs.yasm.reachability;

import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;

/**
 * Describe class ReachabilityProver here.
 *
 *
 * Created: Mon Jun 13 13:17:51 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class ReachabilityProver 
{

  List<ReachabilityProofRule> rules;
  /**
   * Creates a new <code>ReachabilityProver</code> instance.
   *
   */
  public ReachabilityProver() 
  {
    rules = new LinkedList ();
  }

  public void addRule (ReachabilityProofRule rule)
  {
    rules.add (rule);
  }
  
  
  public ProofGoal expand (ProofGoal goal)
  {
    ProofGoal[] subGoals = null;
    
    for (ReachabilityProofRule rule : rules ) {
      subGoals = rule.apply (goal);
      if (subGoals != null) {
        goal.setSubGoals (subGoals);
        break;
      }
    }

    return goal;
  }
  

}
