package edu.toronto.cs.yasm.reachability;

import edu.toronto.cs.yasm.pcfa.*;
import edu.toronto.cs.mvset.MvSet;
import edu.toronto.cs.mvset.MvSetFactory;
import edu.toronto.cs.algebra.*;
import edu.toronto.cs.modelchecker.StatePresenter;

/**
 * Describe class ReachabilityStructure here.
 *
 *
 * Created: Wed Jun  8 15:23:25 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class ReachabilityStructure 
{

  NodeSet sumNodeSet;
  NodeSet nodeSet;
  EdgeSet edgeSet;

  int[] preToAuxMap;
  int[] auxToPostMap;
  int[] postToAuxMap;
  MvSet auxCube;
  MvSet preCube;

  StatePresenter statePresenter;
  
  BelnapAlgebra algebra;
  /**
   * Creates a new <code>ReachabilityStructure</code> instance.
   *
   */
  public ReachabilityStructure (BelnapAlgebra _algebra,
				NodeSet _nodeSet, 
				NodeSet _sumNodeSet,
				EdgeSet _edgeSet,
				int[] _preToAuxMap,
				int[] _auxToPostMap,
				int[] _postToAuxMap,
				MvSet _auxCube,
				MvSet _preCube, 
				StatePresenter _statePresenter)
  {
    algebra = _algebra;
    nodeSet = _nodeSet;
    sumNodeSet = _sumNodeSet;
    edgeSet = _edgeSet;
    preToAuxMap = _preToAuxMap;
    auxToPostMap = _auxToPostMap;
    postToAuxMap = _postToAuxMap;
    auxCube = _auxCube;
    preCube = _preCube;
    statePresenter = _statePresenter;
  }
				
  public BelnapAlgebra getAlgebra ()
  {
    return algebra;
  }
				
  public MvSet getPreCube ()
  {
    return preCube;
  }
				
  public MvSetFactory getMvSetFactory ()
  {
    return auxCube.getFactory ();
  }
  
  public int[] getPreToAuxMap ()
  {
    return preToAuxMap;
  }
  public int[] getAuxToPostMap ()
  {
    return auxToPostMap;
  }
  public int[] getPostToAuxMap ()
  {
    return postToAuxMap;
  }			
  
  public MvSet getAuxCube ()
  {
    return auxCube;
  }
  
  
  public NodeSet getSumNodeSet ()
  {
    return sumNodeSet;
  }
  public void setSumNodeSet (NodeSet v)
  {
    sumNodeSet = v;
  }
  
  public NodeSet getNodeSet ()
  {
    return nodeSet;
  }
  public void setNodeSet (NodeSet v)
  {
    nodeSet = v;
  }
  public EdgeSet getEdgeSet ()
  {
    return edgeSet;
  }
  
  public StatePresenter getStatePresenter ()
  {
    return statePresenter;
  }
  

}
