package edu.toronto.cs.yasm.reachability;

import edu.toronto.cs.yasm.pcfa.*;
import edu.toronto.cs.algebra.*;

/**
 * Describe class StateProofGoal here.
 *
 *
 * Created: Fri Jun 10 16:24:14 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class StateProofGoal extends ProofGoal 
{

  // -- the current set of nodes
  NodeSet nodes;
  
  AlgebraValue value;
  
  Node state;
  
  
  
  /**
   * Creates a new <code>StateProofGoal</code> instance.
   *
   */
  public StateProofGoal (ProofGoal _parent, 
			 NodeSet _nodes, 
			 AlgebraValue _value,
			 Node _state) 
  {
    super (_parent);
    nodes = _nodes;
    value = _value;
    state = _state;
  }

  public NodeSet getNodes ()
  {
    return nodes;
  }
  public AlgebraValue getValue ()
  {
    return value;
  }
  public Node getState ()
  {
    return state;
  }

  public String toString ()
  {
    return state.getId ().toString ();
  }
  
  

}
